# coding=utf-8
#
#
import re
import subprocess

MaxButtons = 20

Programm_sec   = 'Programm'
Bilder_entry   = 'BilderButtons'
BWidth_entry   = 'BilderWidth'
BHeight_entry  = 'BilderHeight'
widthText_entry = 'WidthText'
SchalterAnz_entry = 'ButtonAnzahl'
xpos_entry   = 'xpos'
ypos_entry   = 'ypos'
HFarbe_entry = 'Hintergrundfarbe'
Alpha_entry  = 'Alpha'
FixPos_entry = 'FixedPosition'
BPfad_entry  = 'BilderPfad'
Spalten_entry= 'Spalten'
AlleBildschirme_entry = 'AlleBildschirme'

Schalter_sec = 'Button'
Befehl_entry = 'exec'
Name_entry   = 'Name'
Show_entry   = 'BefehlsAusgabeAnzeigen'
Grafik_entry = 'GrafikName'

IniFileName = 'buttonbar.cfg'
IconName    = 'buttonbar.png'

def Befehl_exec(Befehl):
    # print(Befehl)
    try:
        #Ausgabe = subprocess.run(Befehl, stdout=subprocess.PIPE,stderr=subprocess.PIPE)
        proc = subprocess.Popen(Befehl, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        Ausgabe,err = proc.communicate()
    except Exception as e:
        Ausgabe=''.encode()
    #return Ausgabe.stdout.decode()
    return Ausgabe.decode('utf-8')

def Befehl_execF(Befehl):                  # liefert stderr als Ausgabe
    try:
        #Ausgabe = subprocess.run(Befehl, stdout=subprocess.PIPE,stderr=subprocess.PIPE)
        proc = subprocess.Popen(Befehl, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        Ausgabe,err = proc.communicate()
        err_text = err.decode('utf-8')
    except Exception as e:
        err_text=''
    return err_text.strip()

def StringTrim(s):
    t = s.strip()
    t = t.strip('"')
    return t

def GetMonitors():
    Monitore = []
    M1=''
    M2=''
    Befehl = ['/usr/bin/xrandr', '--query']
    Ausgabe = Befehl_exec(Befehl)
    zeilen = Ausgabe.splitlines()
    for z in zeilen:
        Zeile = z.strip()
        Daten = Zeile.split()
        if (len(Daten)>=4) :
            if Daten[1]=='connected':
                # Virtual1 connected primary 800x600+0+0
                # Virtual2 connected 1024x768+800+0
                if Daten[2]=='primary':
                    if re.match(r'[0-9]+x[0-9]+',Daten[3]):
                        M1=(Daten[3])
                        Werte1 = re.split('x|\+', M1)
                else:
                    if re.match(r'[0-9]+x[0-9]+', Daten[2]):
                        M2=(Daten[2])
                        Werte2 = re.split('x|\+', M2)
    if (M1!='') and (M2 !=''):
        if (Werte1[2]=='0') and (Werte2[2]=='0') :  # gespiegelten Monitor entfernen
            M2= ''
        elif (Werte1[2]!='0') and (Werte2[2]=='0'):
            h = M1
            M1 = M2
            M2 = h
    if M1 != '':
        Monitore.append(M1)
    if M2 != '':
        Monitore.append(M2)
    return Monitore